diff --git a/subsys/shell/shell.c b/subsys/shell/shell.c
index 84d8ff95e88bf..128886d0f882d 100644
--- a/subsys/shell/shell.c
+++ b/subsys/shell/shell.c
@@ -1533,11 +1533,22 @@ static void help_item_print(const struct shell *shell, const char *item_name,
 		return;
 	}
 
+#if !defined(CONFIG_NEWLIB_LIBC) && !defined(CONFIG_ARCH_POSIX)
 	/* print option name */
 	shell_fprintf(shell, SHELL_NORMAL, "%s%-*s%s:",
 		      tabulator,
 		      item_name_width, item_name,
 		      tabulator);
+#else
+	u16_t tmp;
+
+	shell_fprintf(shell, SHELL_NORMAL, "%s%s", tabulator, item_name);
+	tmp = item_name_width - strlen(item_name);
+	for (u16_t i = 0; i < tmp; i++) {
+		shell_fprintf(shell, SHELL_NORMAL, " ");
+	}
+	shell_fprintf(shell, SHELL_NORMAL, "%s:", tabulator);
+#endif
 
 	if (item_help == NULL) {
 		cursor_next_line_move(shell);
